Ruby - Bug #14195

[PATCH] IO#pwrite uses tmp buffer to avoid parallel modification
12/17/2017 10:28 PM - normalperson (Eric Wong)

Status: Closed
Priority: Normal
Assignee: nobu (Nobuyoshi Nakada)

Target version:

ruby -v: Backport:

2.3: UNKNOWN, 2.4: UNKNOWN

Description
Since we release GVL, we must freeze a duplicate the string buffer
to prevent other threads from modifying our buffer while we
are waiting on pwrite(2).
e jo.c (rb_io_pwrite): use_rb_str_tmp_frozen_{acquire/release}

Trivial bugfix, will commit before 2.5 final.

| think some ext/socket methods (sendmsg, setsockopt) may need this, too;
and fentl/ioctl/getsockopt will need locktmp for strings...

Associated revisions

Revision 3b174fb7d6a8883ec64b4f866992b66d86ab3c42 - 12/21/2017 12:26 AM - Eric Wong

io.c: |IO#pwrite uses tmp buffer to avoid parallel modification

Since we release GVL, we must freeze and duplicate the string buffer
to prevent other threads from modifying our buffer while we are
waiting on pwrite(2).

® jo.c (rb_io_pwrite): use_rb_str_tmp_frozen_{acquire/release}
[Bug #14195]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61376 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 3b174fb7 - 12/21/2017 12:26 AM - Eric Wong

io.c: |IO#pwrite uses tmp buffer to avoid parallel modification

Since we release GVL, we must freeze and duplicate the string buffer

to prevent other threads from modifying our buffer while we are

waiting on pwrite(2).

® jo.c (rb_io_pwrite): use_rb_str_tmp_frozen_{acquire/release}
[Bug #14195]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61376 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/17/2017 10:29 PM - normalperson (Eric Wong)
- File 0001-io.c-10-pwrite-uses-tmp-buffer-to-avoid-parallel-mod.patch added

#2 - 12/17/2017 10:32 PM - normalperson (Eric Wong)

normalperson@yhbt.net wrote:

| think some ext/socket methods (sendmsg, setsockopt) may need this, too;
and fentl/ioctl/getsockopt will need locktmp for strings...

N/M, *sockopt do not; but | think others do.
Will work on it later.

#3 - 12/21/2017 12:26 AM - Anonymous

06/16/2025
mailto:normalperson@yhbt.net

- Status changed from Open to Closed

Applied in changeset trunk|r61376.

io.c: IO#pwrite uses tmp buffer to avoid parallel modification

Since we release GVL, we must freeze and duplicate the string buffer
to prevent other threads from modifying our buffer while we are
waiting on pwrite(2).

® jo.c (rb_io_pwrite): use_rb_str_tmp_frozen_{acquire/release}
[Bug #14195]

Files

0001-i0.c-10-pwrite-uses-tmp-buffer-to-avoid-parallel-mod.patch 1.51 KB
